/*******************************************************************************
 * Copyright (c) 2008, 2010 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Nicolas Bros (Mia-Software) - initial API and implementation
 *    
 *******************************************************************************/

package org.eclipse.gmt.modisco.infra.browser.uicore.extensions.naming;

import org.eclipse.emf.ecore.EObject;

/**
 * The interface that must be implemented in order to use the naming extension.
 * Implementors may choose to use the {@link FilteredNameProvider} interface
 * instead if they want to add a filter, or the {@link AbstractNameProvider}
 * class, which implements default naming rules.
 * */
public interface NameProvider {

	/**
	 * @return the name that must be displayed for the given {@link EObject}, or
	 *         <code>null</code> to keep the default name (or let another
	 *         {@link NameProvider} provide the name)
	 */
	String getName(EObject eObject);
}
