/**
 * Copyright (c) 2009 Mia-Software.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabriel Barbier (Mia-Software) - initial API and implementation
 *    Fabien Giquel (Mia-Software) - Bug 339720 : MoDisco Discoverers (infra + techno) API clean
 */

package org.eclipse.gmt.modisco.infra.discoverymanager.ui.launch.utils;

import org.eclipse.core.runtime.Assert;
import org.eclipse.gmt.modisco.infra.discoverymanager.Messages;
import org.eclipse.jface.viewers.ComboBoxCellEditor;

/**
 * @author gbarbier
 * 
 * 
 * @deprecated use org.eclipse.modisco.infra.discovery.core framework
 */
@Deprecated
public class BooleanCellEditor extends ComboBoxCellEditor {

	private final String[] booleanItems = { Messages.BooleanCellEditor_false,
			Messages.BooleanCellEditor_true };

	public BooleanCellEditor() {
		super();
		this.setItems(this.booleanItems);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.TextCellEditor#doGetValue()
	 */
	@Override
	protected Object doGetValue() {
		Boolean result = null;
		Integer index = (Integer) super.doGetValue();
		result = Boolean.valueOf(this.booleanItems[index]);
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.viewers.TextCellEditor#doSetValue(java.lang.Object)
	 */
	@Override
	protected void doSetValue(final Object value) {
		Assert.isTrue(value instanceof Boolean);
		int index = 0;
		if (((Boolean) value) == true) {
			index = 1;
		}
		super.doSetValue(index);
	}

}
